%global commit fcd977cc7f8f6cc7f012e5b72d33cf7d77b3fa69
%global shortcommit %(c=%{commit}; echo ${c:0:7})

Name:		libdxfrw
Version:	1.0.1
Release:	3%{?dist}
Summary:	Library to read/write DXF files
License:	GPLv2+
URL:		https://github.com/LibreCAD/libdxfrw
Source0:	https://github.com/LibreCAD/libdxfrw/archive/%{commit}/%{name}-%{shortcommit}.tar.gz
BuildRequires:	gcc-c++
%if 0%{?epel} == 7
BuildRequires:	cmake3
%else
BuildRequires:	cmake
%endif
# Fix "Vertex ID" printout
# https://github.com/LibreCAD/libdxfrw/pull/55
Patch0:		https://github.com/LibreCAD/libdxfrw/commit/c835b4a365c1fbee96518abbf32e4dbb0955ccfe.patch
# Clean up compiler errors
# https://github.com/LibreCAD/libdxfrw/pull/54
Patch1:		https://patch-diff.githubusercontent.com/raw/LibreCAD/libdxfrw/pull/54.patch
# Fix angle and alignment handling of (m)texts
# https://github.com/LibreCAD/libdxfrw/pull/51
Patch2:		https://github.com/LibreCAD/libdxfrw/commit/3519af1186871cc4bfd66ee670627816473a1ad8.patch
# Fix wrong 2010+ check for 64-bit size
Patch4:		https://github.com/LibreCAD/libdxfrw/commit/5b723c20030b3766006c97c282da96264dc2f722.patch
# Check maxClassNum for valid value
Patch5:		https://github.com/LibreCAD/libdxfrw/commit/5f2afc4dd27f426cc70b5100dc7eda7947e85b47.patch
# Fix bounds check in DRW_LWPolyline
Patch6:		https://github.com/LibreCAD/libdxfrw/commit/5f853313bfb4bf349abbe2d6c822e4407234cbd3.patch
# Add NULL check for hatch code 93
# CVE-2021-45343
Patch7:		https://github.com/LibreCAD/libdxfrw/commit/29266d5492ec7f275c79fbce97ec22ab02ec5ad0.patch
# Protect vector<>.reserve() calls
Patch8:		https://github.com/LibreCAD/libdxfrw/commit/ae253fde529118be213d631efee14d7e8e00b19d.patch
# Remove unused parseCode method
Patch9:		https://github.com/LibreCAD/libdxfrw/commit/1bfc9818535d40335c3a0615d6eeb90f4fa203fa.patch
# Replace ENTRY_PARSE macro with template method
Patch10:	https://github.com/LibreCAD/libdxfrw/commit/14f6870170118225300f47388530529a5a05dc49.patch
# readDwgEntities stop after first error
Patch11:	https://github.com/LibreCAD/libdxfrw/commit/d397170ee31b2152a0d9e1dde922612a01cc21ee.patch
# readDwgObjects stop after first error
Patch12:	https://github.com/LibreCAD/libdxfrw/commit/e23cc1c61ead0fb44a87f7849e8f973cc216dadc.patch
# fix endless while loop for pre-2004 versions
Patch13:	https://github.com/LibreCAD/libdxfrw/commit/b38e2aa746dd7ae0011bc458dcd38166df92979b.patch
# fix ambiguous error for parseDwg
Patch14:	https://github.com/LibreCAD/libdxfrw/commit/072aecd49d835eb83e41572a4ab4d143fdba105a.patch


%description
libdxfrw is a free C++ library to read and write DXF files in both formats,
ASCII and binary form.

%package devel
Summary:	Development files for libdxfrw
Requires:	%{name}%{?_isa} = %{version}-%{release}

%description devel
Development files for libdxfrw.

%prep
%setup -q -n %{name}-%{commit}
%patch0 -p1 -b .fix-vertex-id
%patch1 -p1 -b .pr-54
%patch2 -p1 -b .fix-angle-and-alignment-handling-of-mtexts
%patch4 -p1 -b .fix-wrong-2010-check-for-64bit-size
%patch5 -p1 -b .check-maxClassNum-for-valid-value
%patch6 -p1 -b .fix-bounds-check-in-DRW_LWPolyline
%patch7 -p1 -b .add-NULL-check-for-hatch-code-93
%patch8 -p1 -b .protect-vector-reserve-calls
%patch9 -p1 -b .remove-unused-parseCode
%patch10 -p1 -b .replace-ENTRY_PARSE-macro-with-template-method
%patch11 -p1 -b .readDwgEntities-stop-after-first-error
%patch12 -p1 -b .readDwgObjects-stop-after-first-error
%patch13 -p1 -b .fix-endless-while-loop-for-pre-2004-versions
%patch14 -p1 -b .fix-ambiguous-error-for-parseDwg

%build
%if 0%{?epel} == 7
%cmake3
%cmake3_build
%else
%cmake
%cmake_build
%endif

%install
%if 0%{?epel} == 7
%cmake3_install
%else
%cmake_install
%endif

%ldconfig_scriptlets

%files
%doc AUTHORS ChangeLog COPYING README
%{_bindir}/dwg2dxf
%{_libdir}/*.so.*
%{_mandir}/man1/dwg2dxf.*

%files devel
%{_includedir}/libdxfrw
%{_libdir}/cmake/libdxfrw
%{_libdir}/*.so
%{_libdir}/pkgconfig/libdxfrw.pc

%changelog
* Tue Feb  1 2022 Tom Callaway <spot@fedoraproject.org> - 1.0.1-3
- apply fixes from upstream, including fix for CVE-2021-45343

* Thu Jan 20 2022 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Mon Nov 22 2021 Tom Callaway <spot@fedoraproject.org> - 1.0.1-1
- rebase to new code home, fixes CVE-2021-21898/21899/21900

* Thu Jul 22 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.6.3-19
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Thu May 27 2021 Tom Callaway <spot@fedoraproject.org> - 0.6.3-18
- disable rpath

* Tue Jan 26 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.6.3-17
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Thu Dec 31 2020 Tom Callaway <spot@fedoraproject.org> - 0.6.3-16
- more fixes from LibreCAD git

* Wed Nov  4 2020 Tom Callaway <spot@fedoraproject.org> - 0.6.3-15
- add all of the current fixes from LibreCAD git

* Tue Jul 28 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.6.3-14
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Wed Jan 29 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.6.3-13
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Thu Jul 25 2019 Fedora Release Engineering <releng@fedoraproject.org> - 0.6.3-12
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Fri Feb 01 2019 Fedora Release Engineering <releng@fedoraproject.org> - 0.6.3-11
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Mon Nov 12 2018 Tom Callaway <spot@fedoraproject.org> - 0.6.3-10
- add fix from librecad for CVE-2018-19105

* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.6.3-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Wed Feb 07 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.6.3-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Thu Aug 03 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.6.3-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Binutils_Mass_Rebuild

* Wed Jul 26 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.6.3-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Mon May 15 2017 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.6.3-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_27_Mass_Rebuild

* Fri Feb 10 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.6.3-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Mon Jun  6 2016 Tom Callaway <spot@fedoraproject.org> - 0.6.3-3
- apply changes from LibreCad 2.1.0

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 0.6.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Tue Jan 12 2016 Tom Callaway <spot@fedoraproject.org> - 0.6.3-1
- update to 0.6.3

* Fri Sep 11 2015 Tom Callaway <spot@fedoraproject.org> - 0.6.1-1
- update to 0.6.1

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.5.11-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Sat May 02 2015 Kalev Lember <kalevlember@gmail.com> - 0.5.11-5
- Rebuilt for GCC 5 C++11 ABI change

* Thu Mar 26 2015 Kalev Lember <kalevlember@gmail.com> - 0.5.11-4
- Rebuilt for GCC 5 ABI change

* Sun Aug 17 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.5.11-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.5.11-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Mon Jun  2 2014 Tom Callaway <spot@fedoraproject.org> - 0.5.11-1
- update to 0.5.11
- resync with librecad changes

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.5.7-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Tue Apr 30 2013 Tom Callaway <spot@fedoraproject.org> - 0.5.7-3
- apply fixes from librecad 2.0.0beta5

* Wed Apr 24 2013 Tom Callaway <spot@fedoraproject.org> - 0.5.7-2
- drop empty NEWS and TODO files
- force INSTALL to use -p to preseve timestamps

* Sun Feb 24 2013 Tom Callaway <spot@fedoraproject.org> - 0.5.7-1
- initial package
